; lifegame.lsp
; Life Game
; coding by S&S

;(load "functions.lsp")

;(load "embededsrc/array.lisp")

;(load "jcpplisp.lsp")

(defun lifegame (row column)
    (let ((arr1) (arr2))
	(princ "CtQ[@o[WQ") (terpri)
	(princ "@@@Iɂ̓Rg[b͂Ă") (terpri)
	(setq arr1 (make-array (list row column) :initial-contents (correct-size start-data row column)))
	(setq arr2 (make-array (list row column)))
	(loop
	    (disp arr1 row column)
	    (generate arr1 arr2 row column)
	    (disp arr2 row column)
	    (generate arr2 arr1 row column) ) ) )

(setq start-data
	'((nil)
	  (nil)
	  (nil)
	  (t nil t nil t nil t nil)
	  (t t nil t t t t t nil t t t nil t t t t t t t)
	  (nil)
	  (t t t t t t t t nil t t t t t t t t nil t t)
	  (nil)
	  (t t t nil t t t t nil t t t t t nil t t t t t)
	  (nil)
	  (t t t t t t t t nil t t t t t t t t t t t)
	  (nil)
	  (t t t t t t t t nil t t t t nil t t t t t t)
	  (nil)
	  (t t t t t t t t nil t t t t t t t t t t t)
	  (nil)
	  (t t t t t t t t nil t t t t t t t t t t t)
	  (nil)
	  (t t t t t t t t nil t t t t t t t t t t t)
	  (nil)
	  (t t t t t t t t nil t t t t t t t t t t t)
	  (nil)
	  (t t t t nil t t t nil t t t t nil t t t t t t)
	  (nil)
	  (t t t t t t t t nil t t t t t t t t t t t)
	  (nil)
	  (t t t t t t t t nil t t t t t t t t t t t)
	  (nil)
	  (t t t t t t t t nil t t t t t t t t nil t t)
	  (nil)
	  (t t nil nil t t t t nil t t t t t t t t t t t)
	  (nil)
	  (t nil t t t t t t nil t t t t t t t t t t t)
	  (nil)
	 ) )

(defun correct-size (data row column)
    (let ((i 0) (j) (data1 nil) (data-line) (data-line2))
	(loop
	    (if (= i row) (return))
	    (if (null data)
		(setq data1 (append data1 '((nil))))
		(progn (setq data1 (append data1 (list (car data))))
		       (setq data (cdr data)) ) )
	    (setq i (1+ i)) )
	(setq data data1)
	(setq data1 nil)
	(loop 
	    (if (null data) (return data1))
	    (setq j 0)
	    (setq data-line (car data))
	    (setq data-line1 nil)
	    (loop
		(if (= j column) (return))
		(if (null data-line)
		    (setq data-line1 (append data-line1 '(nil)))
		    (progn (setq data-line1 (append data-line1 (list (car data-line))))
			   (setq data-line (cdr data-line)) ) )
		(setq j (1+ j)) )
	    (setq data (cdr data))
	    (setq data1 (append data1 (list data-line1))) ) ) )

(defun disp (arr row column)
    (let ((y) (x))
	(princ '--------------------------------------------------------) (terpri)
	(setq y 0)
	(loop
	    (if (eql y row) (return t))
	    (setq x 0)
	    (loop
		(if (eql x column) (return t))
	        (if (aref arr y x) (princ "") (princ "E"))
		(setq x (1+ x)) )
	    (terpri)
	    (setq y (1+ y)) ) ) )

(defun generate (old new row column)
    (let ((y) (x) (n))
	(setq y 0)
	(loop
	    (if (eql y row) (return t))
	    (setq x 0)
	    (loop
		(if (eql x column) (return t))
	        (setq n (count-around old y x row column))
		(born-or-die n old new y x)
		(setq x (1+ x)) )
	    (setq y (1+ y)) ) ) )

(defun born-or-die (n old new y x)
    (case n
	((3) (setf (aref new y x) t))
	((2) (if (aref old y x) (setf (aref new y x) t) (setf (aref new y x) nil)))
	((0 1 4 5 6 7 8) (setf (aref new y x) nil)) ) )

(defun count-around (arr y x row column)
    (let ((y1) (x1) (cnt 0))
	(setq y1 (- y 1))
	(setq x1 (- x 1))
	(cond
	    ((< y1 0) nil)
	    ((< x1 0) nil)
	    (t (if (aref arr y1 x1) (setq cnt (1+ cnt)))) )
	(setq y1 (- y 1))
	(setq x1 x)
	(cond
	    ((< y1 0) nil)
	    ((>= x1 column) nil)
	    (t (if (aref arr y1 x1) (setq cnt (1+ cnt)))) )
	(setq y1 (- y 1))
	(setq x1 (+ x 1))
	(cond
	    ((< y1 0) nil)
	    ((>= x1 column) nil)
	    (t (if (aref arr y1 x1) (setq cnt (1+ cnt)))) )
	(setq y1 y)
	(setq x1 (- x 1))
	(cond
	;   ((< y1 0) nil)
	    ((< x1 0) nil)
	    (t (if (aref arr y1 x1) (setq cnt (1+ cnt)))) )
	(setq y1 y)
	(setq x1 (+ x 1))
	(cond
	;   ((< y1 0) nil)
	    ((>= x1 column) nil)
	    (t (if (aref arr y1 x1) (setq cnt (1+ cnt)))) )
	(setq y1 (+ y 1))
	(setq x1 (- x 1))
	(cond
	    ((>= y1 row) nil)
	    ((< x1 0) nil)
	    (t (if (aref arr y1 x1) (setq cnt (1+ cnt)))) )
	(setq y1 (+ y 1))
	(setq x1 x)
	(cond
	    ((>= y1 row) nil)
	;   ((< x1 0) nil)
	    (t (if (aref arr y1 x1) (setq cnt (1+ cnt)))) )
	(setq y1 (+ y 1))
	(setq x1 (+ x 1))
	(cond
	    ((>= y1 row) nil)
	    ((>= x1 column) nil)
	    (t (if (aref arr y1 x1) (setq cnt (1+ cnt)))) )
	cnt ) )

(lifegame 20 20)
